#ifndef PIXELTYPE_H
#define PIXELTYPE_H

enum PixelType {
    BEDROCK, GRASS, TREE, BERRIES, ROCK, IRON_ORE, // nature
    FOOD, WOOD, STONE, IRON, SWORD, // resources
    DUDE, DEAD_DUDE, // humans
    SPAWN, WALL, ROAD, MARK, LIBRARY, // buildings
    EMPTY = -1
};

struct PixelProperty
{
    //we might have to place these function elsewhere ?
    static bool isWalkable(PixelType target)
    {
        return target != WALL
            && target != ROCK
            && target != BEDROCK
            && target != IRON_ORE
            && target != TREE
            && target != LIBRARY
            && target != DUDE
            && target != SPAWN;
    }
    
    static bool isDestructible(PixelType target)
    {
        return target == DUDE
            || target == SPAWN
            || target == WALL
            || target == LIBRARY
            || target == ROAD;
    }
    
    static bool isResource(PixelType target)
    {
        return target == FOOD
            || target == WOOD
            || target == STONE
            || target == IRON
            || target == SWORD;
    }
};

#endif // PIXELTYPE_H
